
import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Queue;
import java.util.TimerTask;

/**
 * Created by fernando on 13/11/16.
 */
public class BFS extends TimerTask{
    /***
     *
     * @param arg
     */
    static int blancos = 0;
    static int negros  = 0;

    public void doStuff(String absolutePath, int a) {
        BufferedImage img;
        Tree tree = new Tree();
        int id = 0;

        try {
            //img = ImageIO.read(new File("/home/fernando/Documents/binary_images/binary-icon-30.png"));
            img = ImageIO.read(new File(absolutePath));
            BufferedImage blackNWhite = new BufferedImage(50, 50, BufferedImage.TYPE_BYTE_BINARY);
            Graphics2D graphics = blackNWhite.createGraphics();
            graphics.drawImage(img, 0, 0, null);

            ImageIO.write(blackNWhite, "jpg", new File("/home/fernando/Documents/binary_images/newBlackNWhite"+a+".jpg"));
            //System.out.println("    Fitxer: " + a);
            img = ImageIO.read(new File("/home/fernando/Documents/binary_images/newBlackNWhite"+a+".jpg"));
            for (int j = 0; j < img.getHeight(); j++) {
                for (int i = 0; i < img.getWidth(); i++) {
                    tree.addNode(img.getRGB(i, j), id++, i, j);
                }
            }
            procedureIterativeBFS(tree.getRoot());


        } catch (IOException e) {
            System.err.print(e.getMessage());
        }
    }

    /***
     *
     * @param root
     */
    public void procedureIterativeBFS(Tree.Node root) {
        try {
            Queue<Tree.Node> stackTree = new LinkedList();
            stackTree.add(root);
            while (!stackTree.isEmpty()) {
                Tree.Node x = stackTree.remove();
                if(x.color == 0) ++negros;
                else ++blancos;
                if (x.right != null) stackTree.add(x.right);
                if (x.left != null) stackTree.add(x.left);
                //System.out.println(" " + x.id);
            }
            //System.out.println("Empty stack.");
        } catch (NullPointerException e) {
            System.err.println(e.getMessage());
        }

    }

    
    public void run() {
        long startTime = System.currentTimeMillis();
        File folder = new File("/home/fernando/proves/fotos");
        File[] listOfFiles = folder.listFiles();

        for (int i = 0; i < listOfFiles.length; i++) {
            if (listOfFiles[i].isFile()) {
                doStuff(listOfFiles[i].getAbsolutePath(),i);
                //System.out.println(i);
            }
        }
        System.out.println("Blancos: "+blancos);
        System.out.println("Negros:  "+negros);
        long endTime   = System.currentTimeMillis();
        long totalTime = endTime - startTime;
        System.out.println("Tiempo: "+totalTime);

    }
}
