//package bfs;
/***
 * Created by Fernando Padilla on 12/11/16.
 */

/**
 * @author Fernando Padilla
 */

public class Tree {

    public int numColor = 0;

    /***
     *
     */
    class Node {
        //public String symbol;
        public int color;  // color ( 1 || 0)
        public int id;
        public int coordX;
        public int coordY;

        public Node parent, right, left;

        public Node(Integer color, Integer id, Integer x, Integer y) {
            this.color = color;
            this.id = id;
            this.coordX = x;
            this.coordY = y;
            parent = null;
            right = null;
            left = null;

        }


        public boolean isLeaf() {
            return this.right == null;
        }
    }

    private Node root;

    public Tree() {
        this.root = null;
    }

    // Add a node to the tree with its color
    public void addNode(int color, int id, int x, int y) {
        int binaryColor = parserColor(color);
        numColor++;
        Node node = new Node(binaryColor, id, x, y);
        //System.out.println("Adding node.");
        // Set new node as root if the tree is empty.
        if (this.root == null) {
            root = node;
            return;
        }

        Node probe = root;
        while (true) {

            // Set new node as current's right child if it has none.
            if (probe.right == null) {
                probe.right = node;
                node.parent = probe;
                break;
            }
            // Set new node as current's left child if it has none.
            if (probe.left == null) {
                probe.left = node;
                node.parent = probe;
                break;
            }
            // Move to left if right child is a leaf node.

            if (probe.right.isLeaf()) {
                probe = probe.left;
            } else {
                // Move to right otherwise.
                probe = probe.right;
            }

        }
    }

    /***
     *
     * @param color
     * @return
     */
    private int parserColor(int color) {
        if (color == -16777216) {
            return 0;
        } else {
            return 1;
        }
    }

    /***
     *
     * @return
     */
    public Node getRoot() {
        return root;
    }
}
