import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.TimerTask;

public class DFS extends TimerTask {
    IterativeDFS iDFS = new IterativeDFS();
    RecursiveDFS rDFS = null;
    Tree.Node nodeRoot = null;

    @Override
    public void run() {
        System.out.println("Starting...");
        long startTime = System.currentTimeMillis();
        File folder = new File("/home/fernando/proves/fotos");
        File[] listOfFiles = folder.listFiles();

        for (int i = 0; i < listOfFiles.length; i++) {
            if (listOfFiles[i].isFile()) {
                doStuff(listOfFiles[i].getAbsolutePath(),i);
                //System.out.println(i);
            }
        }
        long endTime   = System.currentTimeMillis();
        long totalTime = endTime - startTime;
        System.out.println("Tiempo: "+totalTime);


    }

    private void doStuff(String absolutePath, int a) {
        BufferedImage img;
        Tree tree = new Tree();
        int id = 0;

        try {
            img = ImageIO.read(new File(absolutePath));
            BufferedImage blackNWhite = new BufferedImage(15, 15, BufferedImage.TYPE_BYTE_BINARY);
            Graphics2D graphics = blackNWhite.createGraphics();
            graphics.drawImage(img, 0, 0, null);

            ImageIO.write(blackNWhite, "jpg", new File("/home/fernando/Documents/binary_images/newBlackNWhite"+a+".jpg"));
            img = ImageIO.read(new File("/home/fernando/Documents/binary_images/newBlackNWhite"+a+".jpg"));
            for (int j = 0; j < img.getHeight(); j++) {
                for (int i = 0; i < img.getWidth(); i++) {
                    tree.addNode(img.getRGB(i, j), id++, i, j);
                }
            }

            //got a tree

            nodeRoot = tree.getRoot();
	        iDFS = new IterativeDFS();


            iDFS.procedureDFSIterative(nodeRoot);
	    

                       //recursive procedure
            rDFS = new RecursiveDFS(nodeRoot);
            
            rDFS.procedureDFRecursive2(nodeRoot);
            
            

        } catch (IOException e) {
            System.err.print(e.getMessage());
        }

    }
}

