
import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Stack;

/**
 * Created by Fernando on 13/11/16.
 */
public class IterativeDFS {

    public void procedureDFSIterative(Tree.Node nodeRoot) {
        BufferedImage image = new BufferedImage(15, 15, BufferedImage.TYPE_INT_RGB);
        File outputfile = new File("saved.jpeg");
        try {

            Stack<Tree.Node> stackTree = new Stack<>();
            stackTree.add(nodeRoot);
            while (!stackTree.isEmpty()) {
                Tree.Node x = stackTree.pop();
                if (x.right != null) stackTree.add(x.right);
                if (x.left != null) stackTree.add(x.left);
                //if (x.color == 1) System.out.println("Coord: " + x.coordX + " " + x.coordY);
                image.setRGB(x.coordX, x.coordY, new Color(255, 54, 69).getRGB());

                //System.out.println(" " + x.color);
            }
            ImageIO.write(image, "jpeg", outputfile);
            //System.out.println("Empty stack.");
        } catch (NullPointerException e) {
            System.err.println(e.getMessage());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
