

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * Created by Fernando Padilla on 26/11/16.
 */
public class Digraph {

    private Map<String, Node> neighbors = new HashMap<>();

    /***
     *
     * @param id
     * @param node
     */
    public void add(String id, Node node) {
        neighbors.put(id, node);
    }


    /***
     *
     * @param id1
     */
    public void link(int id1, Node node) {
        Node nodeFrom;
        nodeFrom = containsNode(id1);
        if (node != null) {
            if (neighbors.containsKey(String.valueOf(id1))) {
                Iterator nodes = neighbors.get(String.valueOf(id1)).getPairs().iterator();
                if (!nodes.hasNext()) {
                    neighbors.get(String.valueOf(id1)).setPairs(node);
                    return;
                }
                while (nodes.hasNext()) {
                    Node f = (Node) nodes.next();
                    if (f.getId() == id1) {
                        f.setPairs(node);
                    }
                }
            }
        }
    }

    /***
     *
     * @param id1
     * @param id2
     */
    public void link(int id1, int id2) {
        //System.out.println(id1);
        //System.out.println(id2);
        try {
            neighbors.get(String.valueOf(id1)).setPairs(neighbors.get(String.valueOf(id2)));
        }catch(Exception ex){

            }
        //System.out.println("Break here.");
    }

    /***
     *
     * @param from
     * @param to
     * @return
     */
    public void remove(Node from, Node to) {
        if (neighbors.isEmpty()) {
            //System.out.println("Empty graph");
        }
        //TO DO

        //neighbors.get(from).remove(to);
    }

    /***
     *
     * @param id
     * @return
     */
    public boolean contains(int id) {
        return neighbors.containsKey(String.valueOf(id));
        /*
        boolean found = false;
        if (neighbors.containsKey(String.valueOf(id))) {
            Iterator nodes = neighbors.get(String.valueOf(id)).getPairs().iterator();
            while (nodes.hasNext()) {
                Node f = (Node) nodes.next();
                if (f.getId() == id) {
                    found = true;
                }
            }
        }
        return found;*/
    }

    public Node containsNode(int id) {
        return neighbors.get(String.valueOf(id));
        /*
        if (neighbors.containsKey(String.valueOf(id))) {
            Iterator nodes = neighbors.get(String.valueOf(id)).getPairs().iterator();
            while (nodes.hasNext()) {
                Node f = (Node) nodes.next();
                if (f.getId() == id) {
                    return f;
                }
            }
        }

        return null;*/
    }

    public int getNodes() {
        return neighbors.size();
    }

    public Map<String, Node> getNeighbors() {
        return neighbors;
    }

    public Node containsStart() {
        Iterator nodes = neighbors.values().iterator();
        while (nodes.hasNext()) {
            Node f = (Node) nodes.next();
            if(f.getSymbol()=='S'){
                return f;
            }
        }
        return null;
    }
}
