

import java.util.ArrayList;
import java.util.TimerTask;
/**
 * Created by fernando on 17/11/16.
 */

public class Prim {

    Dijkstra dijkstra = new Dijkstra();
    Digraph digraph = null;
    private final int r = 5;
    private final int c = 5;

    @Override
    public void run() {
        System.out.println("Starting...");
        long startTime = System.nanoTime();
        buildMaze();
        long endTime   = System.nanoTime();
        long totalTime = endTime - startTime;
        System.out.println("Tiempo: "+totalTime);
    }

    private  void buildMaze() {

        // dimensions of generated maze
        int r = 5, c = 5;

        // build maze and initialize with only walls
        StringBuilder s = new StringBuilder(c);
        for (int x = 0; x < c; x++) {
            s.append('*');
        }

        char[][] maz = new char[r][c];
        for (int x = 0; x < r; x++) {
            maz[x] = s.toString().toCharArray();
        }

        // select random point and open as start node
        Point st = new Point((int) (Math.random() * r), (int) (Math.random() * c), null);
        maz[st.r][st.c] = 'S';
        //root node


        // iterate through direct neighbors of node
        ArrayList<Point> frontier = new ArrayList<>();
        for (int x = -1; x <= 1; x++) {
            for (int y = -1; y <= 1; y++) {
                if (x == 0 && y == 0 || x != 0 && y != 0) {
                    continue;
                }
                try {
                    if (maz[st.r + x][st.c + y] == '.') {

                        continue;
                    }
                } catch (Exception ex) { // ignorar ArrayIndexOutOfBounds
                    continue;
                }
                // añadir puntos candidatos a frontier
                frontier.add(new Point(st.r + x, st.c + y, st));
            }
        }

        Point last = null;
        while (!frontier.isEmpty()) {

            // se elige un nodo aleatoriamente
            Point cu = frontier.remove((int) (Math.random() * frontier.size()));
            Point op = cu.opposite();
            try {
                // si el nodo y su opuest son paredes
                if (maz[cu.r][cu.c] == '*') {
                    if (maz[op.r][op.c] == '*') {
                        //abrimos un camino entre nodos    
                        maz[cu.r][cu.c] = '-';
                        maz[op.r][op.c] = '-';
                        // print final maze
                        //guardamos el ultimo nodo para reutilizar
                        last = op;
                        //iterar a través de los vecinos directos del nodo
                        for (int x = -1; x <= 1; x++) {
                            for (int y = -1; y <= 1; y++) {
                                if (x == 0 && y == 0 || x != 0 && y != 0) {
                                    continue;
                                }
                                try {

                                    if (maz[op.r + x][op.c + y] == '.') {
                                        continue;
                                    }

                                } catch (Exception ex) {
                                    continue;
                                }
                                frontier.add(new Point(op.r + x, op.c + y, op));

                            }
                        }
                    }
                }


            } catch (Exception ex) { // ignorar NullPointer y ArrayIndexOutOfBounds
                //System.out.println("Some null");
            }
            // si el algoritmo ha cabado, marcanos el último nodo como final E
            if (frontier.isEmpty()) {
                maz[last.r][last.c] = 'E';
            }



        }

        // print final maze
        for (int i = 0; i < r; i++) {
            for (int j = 0; j < c; j++) {
                //System.out.print(maz[i][j]);
            }
            //System.out.println();
        }
        buildGraphFromMaze(maz);
    }

    private void buildGraphFromMaze(char[][] maz) {
        digraph = new Digraph();
        dijkstra = new Dijkstra();

        Node rootNode = null;
        Node tempNode;
        Node node;
        int id = 0;
        int countNodes = 0;
        int idTemp = 0;
        // print final maze
        try {

            //primera parte de crear el grafo
            for (int i = 0; i < r; i++) {
                for (int j = 0; j < c; j++) {
                    //each node has an id
                    if(maz[i][j] == 'S'){
                        rootNode = new Node(id,maz[i][j]); // queremos saber que id tiene el nodo root
                    }
                    Node node2 = new Node(id++, maz[i][j]);
                    //System.out.println("Input node " + node2.getId());
                    if (digraph.getNodes() == 0) { // el grafo esta vacio
                        digraph.add(String.valueOf(id), node2);
                    } else if (digraph.getNodes() > 1) {//significa que podemos repetir el nodo
                        if (digraph.contains(id)) { //if id exists, dont add
                            //System.out.println("Already got it.");
                        } else {
                            digraph.add(String.valueOf(id), node2);
                        }

                    }
                    idTemp = id;

                    if (j + 1 == r) {
                        continue;
                    } else {
                        tempNode = new Node(idTemp++, maz[i][j + 1]);
                        //System.out.println("Temporal node " + tempNode.getId());
                        digraph.add(String.valueOf(idTemp), tempNode);
                        digraph.link(id, tempNode);

                    }
                }
            }

        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
        //add  edge, up to down
        int num = r*c;
        for (int i = 1; i < 6; i++) {
            digraph.link(i, i + r);
        }
        for (int i = 6; i < 11; i++) {
            digraph.link(i, i + r);
        }
        for (int i = 11; i < 16; i++) {
            digraph.link(i, i + r);
        }
        for (int i = 16; i < 21; i++) {
            digraph.link(i, i + r);
        }
        //down to up
        for (int i = 25; i > 20; i--) {
            digraph.link(i, i - r);
        }
        for (int i = 20; i > 15; i--) {
            digraph.link(i, i - r);
        }
        for (int i = 15; i > 10; i--) {
            digraph.link(i, i - r);
        }
        for (int i = 10; i > 5; i--) {
            digraph.link(i, i - r);
        }

        for (int i = 5; i > 0; i--) {
            digraph.link(i, i - r);
        }

        //add  edge, up to left
        for (int i = 25; i > 20; i--) {
            digraph.link(i, i - 1);
        }
        for (int i = 20; i > 15; i--) {
            digraph.link(i, i - 1);
        }
        for (int i = 15; i > 10; i--) {
            digraph.link(i, i - 1);
        }
        for (int i = 10; i > 5; i--) {
            digraph.link(i, i - 1);
        }

        for (int i = 5; i > 0; i--) {
            digraph.link(i, i - 1);
        }

        //System.out.println("Number of nodes in graph " + digraph.getNodes());
        rootNode = digraph.containsStart();
        dijkstra.doDijkstra(digraph.getNeighbors(),rootNode);
    }




    class Point {

        Integer r;
        Integer c;
        Point parent;

        public Point(int x, int y, Point p) {
            r = x;
            c = y;
            parent = p;
        }

        public Point(int x, int y) {
            r = x;
            c = y;
        }
        // compute opposite node given that it is in the other direction from the parent

        public Point opposite() {
            if (this.r.compareTo(parent.r) != 0) {
                return new Point(this.r + this.r.compareTo(parent.r), this.c, this);
            }
            if (this.c.compareTo(parent.c) != 0) {
                return new Point(this.r, this.c + this.c.compareTo(parent.c), this);
            }
            return null;
        }
    }
}

